use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum BitOperationFunction {
    And(super::BitAndFunction),
    Or(super::BitOrFunction),
    Xor(super::BitXorFunction),
    ShiftRight(super::BitShiftRightFunction),
    ShiftLeft(super::BitShiftLeftFunction),
    BitTest(super::BitTestFunction),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for BitOperationFunction {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            BitOperationFunction::And(value) => {
                map.serialize_entry(&"type", &"and")?;
                map.serialize_entry(&"and", value)?;
            }
            BitOperationFunction::Or(value) => {
                map.serialize_entry(&"type", &"or")?;
                map.serialize_entry(&"or", value)?;
            }
            BitOperationFunction::Xor(value) => {
                map.serialize_entry(&"type", &"xor")?;
                map.serialize_entry(&"xor", value)?;
            }
            BitOperationFunction::ShiftRight(value) => {
                map.serialize_entry(&"type", &"shiftRight")?;
                map.serialize_entry(&"shiftRight", value)?;
            }
            BitOperationFunction::ShiftLeft(value) => {
                map.serialize_entry(&"type", &"shiftLeft")?;
                map.serialize_entry(&"shiftLeft", value)?;
            }
            BitOperationFunction::BitTest(value) => {
                map.serialize_entry(&"type", &"bitTest")?;
                map.serialize_entry(&"bitTest", value)?;
            }
            BitOperationFunction::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for BitOperationFunction {
    fn deserialize<D>(d: D) -> Result<BitOperationFunction, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = BitOperationFunction;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union BitOperationFunction")
    }
    fn visit_map<A>(self, mut map: A) -> Result<BitOperationFunction, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::And, Some(Variant_::And)) => {
                        let value = map.next_value()?;
                        BitOperationFunction::And(value)
                    }
                    (Variant_::Or, Some(Variant_::Or)) => {
                        let value = map.next_value()?;
                        BitOperationFunction::Or(value)
                    }
                    (Variant_::Xor, Some(Variant_::Xor)) => {
                        let value = map.next_value()?;
                        BitOperationFunction::Xor(value)
                    }
                    (Variant_::ShiftRight, Some(Variant_::ShiftRight)) => {
                        let value = map.next_value()?;
                        BitOperationFunction::ShiftRight(value)
                    }
                    (Variant_::ShiftLeft, Some(Variant_::ShiftLeft)) => {
                        let value = map.next_value()?;
                        BitOperationFunction::ShiftLeft(value)
                    }
                    (Variant_::BitTest, Some(Variant_::BitTest)) => {
                        let value = map.next_value()?;
                        BitOperationFunction::BitTest(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            BitOperationFunction::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::And => {
                        let value = map.next_value()?;
                        BitOperationFunction::And(value)
                    }
                    Variant_::Or => {
                        let value = map.next_value()?;
                        BitOperationFunction::Or(value)
                    }
                    Variant_::Xor => {
                        let value = map.next_value()?;
                        BitOperationFunction::Xor(value)
                    }
                    Variant_::ShiftRight => {
                        let value = map.next_value()?;
                        BitOperationFunction::ShiftRight(value)
                    }
                    Variant_::ShiftLeft => {
                        let value = map.next_value()?;
                        BitOperationFunction::ShiftLeft(value)
                    }
                    Variant_::BitTest => {
                        let value = map.next_value()?;
                        BitOperationFunction::BitTest(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        BitOperationFunction::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    And,
    Or,
    Xor,
    ShiftRight,
    ShiftLeft,
    BitTest,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::And => "and",
            Variant_::Or => "or",
            Variant_::Xor => "xor",
            Variant_::ShiftRight => "shiftRight",
            Variant_::ShiftLeft => "shiftLeft",
            Variant_::BitTest => "bitTest",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "and" => Variant_::And,
            "or" => Variant_::Or,
            "xor" => Variant_::Xor,
            "shiftRight" => Variant_::ShiftRight,
            "shiftLeft" => Variant_::ShiftLeft,
            "bitTest" => Variant_::BitTest,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the BitOperationFunction union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
